#include "umatrix.h"

void unimult(int **A, int **B, int **C, int **R, int N) {
  int writeRow,writeCol,index;
  int sum;

  // do first mult, R = A*B
  for(writeRow=0;writeRow<N;writeRow++) {
    for(writeCol=0;writeCol<N;writeCol++) {
      sum = 0;
      for(index=0;index<N;index++) {
        sum += A[writeRow][index] * B[index][writeCol];
      }

      R[writeRow][writeCol] = sum;
    }
  }

  // do second mult, A = R*C
  // R->A, A->R, B->C
  for(writeRow=0;writeRow<N;writeRow++) {
    for(writeCol=0;writeCol<N;writeCol++) {
      sum = 0;
      for(index=0;index<N;index++) {
        sum += R[writeRow][index] * C[index][writeCol];
      }

      A[writeRow][writeCol] = sum;
    }
  }

}
